require '_h2ph_pre.ph';

unless(defined(&_SYS_FS_S5_INODE_H)) {
    eval 'sub _SYS_FS_S5_INODE_H () {1;}' unless defined(&_SYS_FS_S5_INODE_H);
    require 'sys/fbuf.ph';
    require 'sys/fcntl.ph';
    require 'sys/uio.ph';
    require 'sys/t_lock.ph';
    require 'sys/fs/s5_fs.ph';
    require 'sys/fs/s5_lockfs.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub NADDR () {13;}' unless defined(&NADDR);
    eval 'sub NDADDR () {10;}' unless defined(&NDADDR);
    eval 'sub NIADDR () {( &NADDR- &NDADDR);}' unless defined(&NIADDR);
    eval 'sub NSADDR () {( &NADDR * $sizeof{ &daddr_t}/$sizeof{\'short\'});}' unless defined(&NSADDR);
    eval 'sub NINDIR {
        local($s5vfs) = @_;
	    eval q((($s5vfs)-> &vfs_bsize / $sizeof{ &daddr_t}));
    }' unless defined(&NINDIR);
    eval 'sub i_fs () { ($i_s5vfs->{vfs_bufp}->{b_un}->{b_fs});}' unless defined(&i_fs);
    eval 'sub i_oldrdev () { $i_addr[0];}' unless defined(&i_oldrdev);
    eval 'sub i_bcflag () { $i_addr[1];}' unless defined(&i_bcflag);
    eval 'sub NDEVFORMAT () {0x1;}' unless defined(&NDEVFORMAT);
    eval 'sub i_major () { $i_addr[2];}' unless defined(&i_major);
    eval 'sub i_minor () { $i_addr[3];}' unless defined(&i_minor);
    eval 'sub INOACC () {0x0001;}' unless defined(&INOACC);
    eval 'sub IUPD () {0x0002;}' unless defined(&IUPD);
    eval 'sub IACC () {0x0004;}' unless defined(&IACC);
    eval 'sub IREF () {0x0010;}' unless defined(&IREF);
    eval 'sub ICHG () {0x0040;}' unless defined(&ICHG);
    eval 'sub ISYN () {0x0080;}' unless defined(&ISYN);
    eval 'sub IMOD () {0x0100;}' unless defined(&IMOD);
    eval 'sub IMODACC () {0x0200;}' unless defined(&IMODACC);
    eval 'sub ISYNC () {0x0400;}' unless defined(&ISYNC);
    eval 'sub IMODTIME () {0x0800;}' unless defined(&IMODTIME);
    eval 'sub IINACTIVE () {0x2000;}' unless defined(&IINACTIVE);
    eval 'sub IFMT () {0xf000;}' unless defined(&IFMT);
    eval 'sub IFIFO () {0x1000;}' unless defined(&IFIFO);
    eval 'sub IFCHR () {0x2000;}' unless defined(&IFCHR);
    eval 'sub IFDIR () {0x4000;}' unless defined(&IFDIR);
    eval 'sub IFNAM () {0x5000;}' unless defined(&IFNAM);
    eval 'sub IFBLK () {0x6000;}' unless defined(&IFBLK);
    eval 'sub IFREG () {0x8000;}' unless defined(&IFREG);
    eval 'sub IFLNK () {0xa000;}' unless defined(&IFLNK);
    eval 'sub ISUID () { &VSUID;}' unless defined(&ISUID);
    eval 'sub ISGID () { &VSGID;}' unless defined(&ISGID);
    eval 'sub ISVTX () { &VSVTX;}' unless defined(&ISVTX);
    eval 'sub IREAD () { &VREAD;}' unless defined(&IREAD);
    eval 'sub IWRITE () { &VWRITE;}' unless defined(&IWRITE);
    eval 'sub IEXEC () { &VEXEC;}' unless defined(&IEXEC);
    eval 'sub I_SYNC () {1;}' unless defined(&I_SYNC);
    eval 'sub I_ASYNC () {0;}' unless defined(&I_ASYNC);
    if(defined(&_KERNEL)) {
	eval 'sub VTOI {
	    local($VP) = @_;
    	    eval q((($VP)-> &v_data));
	}' unless defined(&VTOI);
	eval 'sub ITOV {
	    local($IP) = @_;
    	    eval q((($IP)-> &i_vnode));
	}' unless defined(&ITOV);
	eval 'sub ITOF {
	    local($IP) = @_;
    	    eval q((($IP)-> &i_fs));
	}' unless defined(&ITOF);
	eval 'sub vfs_fs () { ($vfs_bufp->{b_un}->{b_fs});}' unless defined(&vfs_fs);
	eval 'sub INOHSZ () {512;}' unless defined(&INOHSZ);
	if((((defined(&INOHSZ) ? &INOHSZ : 0) & ((defined(&INOHSZ) ? &INOHSZ : 0) - 1)) == 0)) {
	    eval 'sub INOHASH {
	        local($dev, $ino) = @_;
    		eval q(( &hash2ints($dev, $ino) &  &INOHSZ - 1));
	    }' unless defined(&INOHASH);
	} else {
	    eval 'sub INOHASH {
	        local($dev, $ino) = @_;
    		eval q(( &hash2ints($dev, $ino) %  &INOHSZ));
	    }' unless defined(&INOHASH);
	}
	eval 'sub IMARK {
	    local($ip) = @_;
    	    eval q( &s5_imark($ip));
	}' unless defined(&IMARK);
	eval 'sub ITIMES_NOLOCK {
	    local($ip) = @_;
    	    eval q( &s5_itimes_nolock($ip));
	}' unless defined(&ITIMES_NOLOCK);
	eval 'sub ITIMES {
	    local($ip) = @_;
    	    eval q({  &mutex_enter(($ip)-> &i_tlock);  &ITIMES_NOLOCK($ip);  &mutex_exit(($ip)-> &i_tlock); });
	}' unless defined(&ITIMES);
	eval 'sub FsINOS {
	    local($s5vfs, $ino) = @_;
    	    eval q((((($ino) >> ($s5vfs)-> &vfs_inoshift) << ($s5vfs)-> &vfs_inoshift) + 1));
	}' unless defined(&FsINOS);
	eval 'sub FsITOD {
	    local($s5vfs, $ino) = @_;
    	    eval q(((($ino) + (2*($s5vfs)-> &vfs_inopb-1)) >> ($s5vfs)-> &vfs_inoshift));
	}' unless defined(&FsITOD);
	eval 'sub itod {
	    local($s5vfs, $x) = @_;
    	    eval q((($x+(2* ($s5vfs->{vfs_inopb})-1)) >> ( ($s5vfs->{vfs_inoshift}))));
	}' unless defined(&itod);
	eval 'sub itoo {
	    local($s5vfs, $x) = @_;
    	    eval q((($x-1)& ( ($s5vfs->{vfs_inopb})-1)));
	}' unless defined(&itoo);
	eval 'sub BMAPALLOC {
	    local($ip, $off, $size, $cr) = @_;
    	    eval q( &s5_bmap_write(($ip), ($off), ($size), 0, $cr));
	}' unless defined(&BMAPALLOC);
	eval 'sub ESAME () {(-1);}' unless defined(&ESAME);
	eval 'sub OWNER {
	    local($CR, $IP) = @_;
    	    eval q(((($CR)-> &cr_uid == ($IP)-> &i_uid)? 0: ( &suser($CR)? 0:  &EPERM)));
	}' unless defined(&OWNER);
	eval 'sub S5_HOLE () {0;}' unless defined(&S5_HOLE);
	eval("sub DE_CREATE () { 0; }") unless defined(&DE_CREATE);
	eval("sub DE_MKDIR () { 1; }") unless defined(&DE_MKDIR);
	eval("sub DE_LINK () { 2; }") unless defined(&DE_LINK);
	eval("sub DE_RENAME () { 3; }") unless defined(&DE_RENAME);
	eval("sub DR_REMOVE () { 0; }") unless defined(&DR_REMOVE);
	eval("sub DR_RMDIR () { 1; }") unless defined(&DR_RMDIR);
	eval("sub DR_RENAME () { 2; }") unless defined(&DR_RENAME);
    }
    eval 'sub blkoff {
        local($s5vfs, $loc) = @_;
	    eval q((($loc) & ($s5vfs)-> &vfs_bmask));
    }' unless defined(&blkoff);
    eval 'sub lblkno {
        local($s5vfs, $loc) = @_;
	    eval q((($loc) >> ($s5vfs)-> &vfs_bshift));
    }' unless defined(&lblkno);
    eval 'sub blkroundup {
        local($s5vfs, $size) = @_;
	    eval q(((($size) + ($s5vfs)-> &vfs_bmask) & ~($s5vfs)-> &vfs_bmask));
    }' unless defined(&blkroundup);
    if(defined( &_KERNEL)  && defined( &__STDC__)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
